3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE
='[-v] [--onto <newbase>] <upstream> [<branch>]'
7 LONG_USAGE
='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .dotest working files, use the command
18 git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used. You must be in the top
22 directory of your project to start (or continue) a rebase.
24 Example: git-rebase master~1 topic
26 A---B---C topic A'\''--B'\''--C'\'' topic
28 D---E---F---G master D---E---F---G master
33 When you have resolved this problem run \"git rebase --continue\".
34 If you would prefer to skip this patch, instead run \"git rebase --skip\".
35 To restore the original branch and stop rebasing run \"git rebase --abort\".
40 dotest
=$GIT_DIR/.dotest-merge
45 test -n "$prev_head" || die
"prev_head must be defined"
46 test -d "$dotest" || die
"$dotest directory does not exist"
48 unmerged
=$
(git-ls-files
-u)
49 if test -n "$unmerged"
51 echo "You still have unmerged paths in your index"
52 echo "did you forget update-index?"
56 if test -n "`git-diff-index HEAD`"
58 if ! git-commit
-C "`cat $dotest/current`"
60 echo "Commit failed, please do not call \"git commit\""
61 echo "directly, but instead do one of the following: "
64 printf "Committed: %0${prec}d" $msgnum
66 printf "Already applied: %0${prec}d" $msgnum
68 echo ' '`git-rev-list --pretty=oneline -1 HEAD | \
69 sed 's/^[a-f0-9]\+ //'`
71 prev_head
=`git-rev-parse HEAD^0`
72 # save the resulting commit so we can read-tree on it later
73 echo "$prev_head" > "$dotest/prev_head"
75 # onto the next patch:
76 msgnum
=$
(($msgnum + 1))
77 echo "$msgnum" >"$dotest/msgnum"
81 cmt
="$(cat $dotest/cmt.$1)"
82 echo "$cmt" > "$dotest/current"
83 git-merge-
$strategy "$cmt^" -- HEAD
"$cmt"
90 test -d "$GIT_DIR/rr-cache" && git-rerere
94 echo "Strategy: $rv $strategy failed, try another" 1>&2
98 die
"Unknown exit code ($rv) from command:" \
99 "git-merge-$strategy $cmt^ -- HEAD $cmt"
109 while case "$#" in 0) break ;; esac
113 diff=$
(git-diff-files
)
115 ?
*) echo "You must edit all merge conflicts and then"
116 echo "mark them as resolved using git update-index"
122 prev_head
="`cat $dotest/prev_head`"
123 end
="`cat $dotest/end`"
124 msgnum
="`cat $dotest/msgnum`"
125 onto
="`cat $dotest/onto`"
127 while test "$msgnum" -le "$end"
135 git am
--resolved --3way --resolvemsg="$RESOLVEMSG" \
136 --reflog-action=rebase
142 if test -d "$GIT_DIR/rr-cache"
146 prev_head
="`cat $dotest/prev_head`"
147 end
="`cat $dotest/end`"
148 msgnum
="`cat $dotest/msgnum`"
149 msgnum
=$
(($msgnum + 1))
150 onto
="`cat $dotest/onto`"
151 while test "$msgnum" -le "$end"
159 git am
-3 --skip --resolvemsg="$RESOLVEMSG" \
160 --reflog-action=rebase
164 if test -d "$GIT_DIR/rr-cache"
175 die
"No rebase in progress?"
177 git
reset --hard ORIG_HEAD
181 test 2 -le "$#" || usage
185 -M|
-m|
--m|
--me|
--mer|
--merg|
--merge)
188 -s=*|
--s=*|
--st=*|
--str=*|
--stra=*|
--strat=*|
--strate=*|\
189 --strateg=*|
--strategy=*|\
190 -s|
--s|
--st|
--str|
--stra|
--strat|
--strate|
--strateg|
--strategy)
193 strategy
=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
215 # Make sure we do not have .dotest
216 if test -z "$do_merge"
223 It seems that I cannot create a .dotest directory, and I wonder if you
224 are in the middle of patch application or another rebase. If that is not
225 the case, please rm -fr .dotest and run me again. I am stopping in case
226 you still have something valuable there.'
232 die
"previous dotest directory $dotest still exists." \
233 'try git-rebase < --continue | --abort >'
237 # The tree must be really really clean.
238 git-update-index
--refresh ||
exit
239 diff=$
(git-diff-index
--cached --name-status -r HEAD
)
246 # The upstream head must be given. Make sure it is valid.
248 upstream
=`git rev-parse --verify "${upstream_name}^0"` ||
249 die
"invalid upstream $upstream_name"
251 # If a hook exists, give it a chance to interrupt
252 if test -x "$GIT_DIR/hooks/pre-rebase"
254 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
{
255 echo >&2 "The pre-rebase hook refused to rebase."
260 # If the branch to rebase is given, first switch to it.
264 git-checkout
"$2" || usage
267 branch_name
=`git symbolic-ref HEAD` || die
"No current branch"
268 branch_name
=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
271 branch
=$
(git-rev-parse
--verify "${branch_name}^0") ||
exit
273 # Make sure the branch to rebase onto is valid.
274 onto_name
=${newbase-"$upstream_name"}
275 onto
=$
(git-rev-parse
--verify "${onto_name}^0") ||
exit
277 # Now we are rebasing commits $upstream..$branch on top of $onto
279 # Check if we are already based on $onto, but this should be
280 # done only when upstream and onto are the same.
281 mb
=$
(git-merge-base
"$onto" "$branch")
282 if test "$upstream" = "$onto" && test "$mb" = "$onto"
284 echo >&2 "Current branch $branch_name is up to date."
288 if test -n "$verbose"
290 echo "Changes from $mb to $onto:"
291 git-diff-tree
--stat --summary "$mb" "$onto"
294 # Rewind the head to "$onto"; this saves our current head in ORIG_HEAD.
295 echo "First, rewinding head to replay your work on top of it..."
296 git-reset
--hard "$onto"
298 # If the $onto is a proper descendant of the tip of the branch, then
299 # we just fast forwarded.
300 if test "$mb" = "$branch"
302 echo >&2 "Fast-forwarded $branch_name to $onto_name."
306 if test -z "$do_merge"
308 git-format-patch
-k --stdout --full-index --ignore-if-in-upstream "$upstream"..ORIG_HEAD |
309 git am
--binary -3 -k --resolvemsg="$RESOLVEMSG" \
310 --reflog-action=rebase
314 # start doing a rebase with git-merge
315 # this is rename-aware if the recursive (default) strategy is used
318 echo "$onto" > "$dotest/onto"
319 prev_head
=`git-rev-parse HEAD^0`
320 echo "$prev_head" > "$dotest/prev_head"
323 for cmt
in `git-rev-list --no-merges "$upstream"..ORIG_HEAD \
324 | @@PERL@@ -e 'print reverse <>'`
326 msgnum
=$
(($msgnum + 1))
327 echo "$cmt" > "$dotest/cmt.$msgnum"
330 echo 1 >"$dotest/msgnum"
331 echo $msgnum >"$dotest/end"
336 while test "$msgnum" -le "$end"